require 'observer'

require 'runit/testsuite'
require 'runit/robserver'
require 'runit/error'
require 'runit/assert'

module RUNIT
  class TestCase
    include Assert
    include Observable

    def initialize(method, name=self.type.name)
      @method = method
      @name = name
    end

    def setup
    end
    private :setup

    def teardown
    end
    private :teardown

    def setup_assert
      changed
      notify_observers(RObserver::SETUP_ASSERT)
    end

    def name
      @name + "#" +  @method
    end

    def run(test_result)
      test_result.run(self)
    end
  
    def run_bare
      setup
      begin 
        send(@method)
      ensure
        teardown
      end
    end
        
    def count_test_cases()
      1
    end
  
    def TestCase.suite
      TestSuite.new(self)
    end
  end
end
